# Contributing to knex-migration-with-schema

We want to make contributing to this project as easy and transparent as possible, whether it's:

- Reporting a bug
- Proposing new features
- Submitting a pull request for new features of bug fixes

## Running the tests locally

We use docker compose for running the tests. You need to have [docker](https://www.docker.com/) and [docker-compose](https://docs.docker.com/compose/) installed.

1. Start your Docker
1. Run the following commands in the root folder of this project

```bash
  npm run dnpmi
  npm run dt
```

## We Develop with Github

We use github to host code, to track issues and feature requests, as well as accept pull requests.

## We Use [Github Flow](https://guides.github.com/introduction/flow/index.html), So All Code Changes Happen Through Pull Requests

Pull requests are the best way to propose changes to the codebase (we use [Github Flow](https://guides.github.com/introduction/flow/index.html)). We actively welcome your pull requests:

1. Fork the repo and create your branch from `master`.
2. Install the dependencies, to be able to run the tests: `npm run install`
3. If you've added code that should be tested, add tests.
4. Ensure the test suite passes by running `npm run test`
5. Update the documentation on README.md if needed
6. Issue that pull request!

## Any contributions you make will be under the MIT Software License

In short, when you submit code changes, your submissions are understood to be under the same [MIT License](http://choosealicense.com/licenses/mit/) that covers the project. Feel free to contact the maintainers if that's a concern.

## Report bugs using Github's [issues](https://github.com/wgrisa/knex-migration-with-schema/issues)

We use GitHub issues to track public bugs. Report a bug by [opening a new issue](); it's that easy!

**Great Bug Reports** tend to have:

- A quick summary and/or background
- Steps to reproduce
- What you expected would happen
- What actually happens
- Notes (possibly including why you think this might be happening, or stuff you tried that didn't work)

## License

By contributing, you agree that your contributions will be licensed under its [MIT License](https://www.mit.edu/~amini/LICENSE.md).

## References

This document was adapted from the open-source contribution guidelines for [Transcriptase](https://gist.github.com/briandk/3d2e8b3ec8daf5a27a62).
