"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.executeSchemaMigrationFromDir = exports.executeSchemaMigration = void 0;
const fs_1 = require("fs");
const buildMigrationSource = ({ schemaName, migrations, }) => ({
    getMigrations() {
        return Promise.resolve(Object.keys(migrations));
    },
    getMigrationName(migration) {
        return migration;
    },
    getMigration(migration) {
        return migrations[migration](schemaName);
    },
});
exports.executeSchemaMigration = ({ knex, schemaName, migrations, }) => {
    const migrationSource = buildMigrationSource({ schemaName, migrations });
    return knex.migrate
        .latest({
        schemaName,
        migrationSource,
    })
        .catch((error) => {
        return error;
    });
};
exports.executeSchemaMigrationFromDir = ({ knex, schemaName, directory, }) => __awaiter(void 0, void 0, void 0, function* () {
    let fileNames;
    try {
        fileNames = yield fs_1.promises.readdir(directory);
    }
    catch (_a) {
        return `Could not read directory "${directory}"`;
    }
    const migrations = {};
    for (const filename of fileNames) {
        const filePath = `${directory}/${filename}`;
        yield Promise.resolve().then(() => __importStar(require(filePath))).then((migration) => {
            migrations[filename] = migration.default;
        });
    }
    return exports.executeSchemaMigration({ knex, schemaName, migrations });
});
//# sourceMappingURL=migration.js.map